*	Copyright 1993 Eugene Mondrus & Impath Laboratories
*	Procedure to restore enviroment saved by SAVENV
*	to a file
*	Usage : =restenv(filename)
*	Returns: (nothing)
*	This file is hereby released for general public use and
*	is free to be distributed and copied AS LONG AS NO MONIES
*   THIS PRODUCT IS OFFERED "AS IS" WITHOUT  ANY  WARRANTY  OF  ANY  KIND
*   INCLUDING,  BUT  NOT  LIMITED TO IMPLIED WARRANTIES OF MERCHANTABILITY
*   AND FITNESS FOR A PARTICULAR  PURPOSE,  ALL  OF  WHICH  ARE  EXPRESSLY
*   DISCLAIMED.  SHOULD THE PROGRAM PROVE DEFECTIVE, THE USER ASSUMES
*   THE RISK OF PAYING THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR,
*   OR  CORRECTION  AND  ANY  INCIDENTAL  OR CONSEQUENTIAL DAMAGES.  IN NO
*   EVENT WILL Impath Laboratories or Eugene Mondrus  BE  LIABLE  FOR  ANY
*   DAMAGES  WHATSOEVER (INCLUDING  WITHOUT  LIMITATION  DAMAGES FOR LOSS 
*   OF BUSINESS PROFITS,BUSINESS INTERRUPTION, LOSS OF BUSINESS INFORMATION
*   AND  THE  LIKE)ARISING OUT OF THE USE OR THE INABILITY TO USE THIS
*   PRODUCT EVEN IF Impath Laboratories or Eugene Mondrus HAS BEEN ADVISED
*   OF THE POSSIBILITY OF SUCH DAMAGES.
*
*	Revisions
* 	10/29/93	5:18	EM	Would give an error message when tried to go
*							past EOF() in a file with 0 records, fixed with an IF
*	11/1/93		8:30	EM	Have to handle set skip for each individual work area
*							not just for the whole enviroment
*
*

function restenv
parameter tempfile

private maxworkarea,currarea,currused,currarea,m_save_set,tempcount


EXTERNAL ARRAY m_savework
EXTERNAL ARRAY m_save_set

*1 	is physical name of database
*2 	is alias of database
*3 	is any filter expressions for database
*4 	is all relations in a string, parsed with command code
*		ready for execution		i.e. : "set relation to XXX into YYY
*5 	is all indexes (IDX&CDX) files ready to be called like above
*6 	is controlling index
*7 	Record pointer in current database
*8 	is database used exclusively or not
*9 	String neccesary to unset relations
*10 Set skip for this work area

restore from (tempfile) additive	&& restore from file

do case
	case "2.0" $ version()
		maxworkarea=25		&& if were running fox 2.0 max work areas = 25
	case !("(X)"  $ version())
		maxworkarea=25		&& if were not running extended max work areas = 25
	case "(X)" $ version()
		maxworkarea=225		&& if we are running extended max work areas = 225	
	otherwise
		maxworkarea=25		&& Default is 25
endcase


declare currused[maxworkarea]


for currarea=1 to maxworkarea
	currused[currarea]=dbf(currarea)		&& store the currently used database into an array
endfor


for currarea=1 to maxworkarea
	

	if empty(m_savework[currarea,1])	&& if database was not used close the current one
		if !empty(alias(currarea))
			use in (currarea)
		endif
		loop					&& go back to the top
	endif


	select (currarea)	&& Must select because filter doesn't have
						&& in (currarea) extension
			

* Start open database
				
*	if database is a different name or  database is a different alias or
* 	database used with a different exclusive than before close the database

	if 	(dbf(currarea)<>m_savework[currarea,1])	.or.;	
		(alias(currarea)<>m_savework[currarea,2])  .or.;	
		(sys(2011)<>m_savework[currarea,8])		
		
		scanarea=ascan(currused,m_savework[currarea,1])		&& Look through the array if the physical DBF is in use
		do while scanarea<>0								&& while it is in use do
		  	use in (scanarea)								&& close it
		  	=adel(currused,scanarea)						&& Delete reference from array
		  	scanarea=ascan(currused,m_savework[currarea,1]) && look for it again
*		  	select (currarea)								&& if found currarea<>0 else currarea=0
		enddo
		
*		use the physical database with the correct alias in the correct area either exclusively or not
		
		use (m_savework[currarea,1]) alias (m_savework[currarea,2]) in (currarea) &m_savework[currarea,8] 
		
*		set the correct IDX		

		set	index to &m_savework[currarea,5]
		
*		set the correct CDX

		set order to &m_savework[currarea,6]
		
*		go to the right record
*		up to you to make sure the record still exists

		if m_savework[currarea,7]>reccount(currarea)	&& if we were at EOF of file
			go bottom in (currarea)	&& go to bottom of file
			if reccount()>0
				skip 1 in (currarea)		&& Now go to EOF which is 1 past bottom of file
			endif
		else
			go (m_savework[currarea,7]) in (alias(currarea))
		endif
				
	endif
			
* End Open Database

endfor

for currarea=1 to maxworkarea

	if empty(m_savework[currarea,4])		&& if empty relation string don't bother
		loop
	endif
	
	select (currarea)						&& select correct work area
	
	numofrels=1
	do while !empty(target(numofrels))  				&& if current database has relations
		if 	(target(numofrels)$m_savework[currarea,9])	&& and they are in the set we saved	
			set relation off into target(numofrels)		&& Turn themoff
			numofrels=numofrels-1						&& Since we just deleted one, set the counter back 1
		endif
		numofrels=numofrels+1							&& and keep checking
	enddo

	set relation to &m_savework[currarea,4]	&& set relations on
endfor

for currarea=1 to maxworkarea
	set skip to &m_savework[currarea,10]	&& restore set skip settings
endfor
	


*	Restore all previous sets

SET ALTERNATE &m_save_set[1] 
SET ANSI &m_save_set[2]
SET AUTOSAVE &m_save_set[3]
SET BELL &m_save_set[4]
SET BLINK &m_save_set[5]
SET BLOCKSIZE TO (m_save_set[6])
SET BRSTATUS &m_save_set[7]
SET CARRY &m_save_set[8]
SET CENTURY &m_save_set[9]
SET CLEAR &m_save_set[10]
SET CLOCK &m_save_set[11]
SET COLOR TO &m_save_set[12]
SET COMPATIBLE &m_save_set[13]
SET CONFIRM &m_save_set[14]
SET CONSOLE &m_save_set[15]
SET CURRENCY &m_save_set[16]
SET CURSOR &m_save_set[17]
SET DATE &m_save_set[18]
SET DEBUG &m_save_set[19]
SET DECIMALS TO &m_save_set[20]
SET DEFAULT TO &m_save_set[21]
SET DELETED &m_save_set[22]
SET DELIMITERS &m_save_set[23]
SET DEVICE TO &m_save_set[24]
SET DOHISTORY &m_save_set[25]
SET ECHO &m_save_set[26]
SET ESCAPE &m_save_set[27]
SET EXACT &m_save_set[28]
SET EXCLUSIVE &m_save_set[29]
SET FIXED &m_save_set[30]
SET FULLPATH &m_save_set[31]
SET HEADING &m_save_set[32]
SET HELP &m_save_set[33]
SET HISTORY &m_save_set[34]
SET HOURS TO &m_save_set[35]
SET INTENSITY &m_save_set[36]
SET LOCK &m_save_set[37]
SET LOGERRORS &m_save_set[38]
SET MACKEY TO &m_save_set[39]
SET MARGIN TO (m_save_set[40])
SET MARK TO &m_save_set[41]
SET MEMOWIDTH TO (m_save_set[42])
SET MENU &m_save_set[43]
SET MESSAGE TO &m_save_set[44]
SET MULTILOCKS &m_save_set[45]
SET NEAR &m_save_set[46]
SET NOTIFY &m_save_set[47]
SET ODOMETER TO (m_save_set[48])
SET OPTIMIZE &m_save_set[49]
SET PATH TO &m_save_set[50]
SET POINT TO &m_save_set[51]
SET PRINTER &m_save_set[52]
SET REFRESH TO (m_save_set[53])
SET REPROCESS TO (m_save_set[54])
SET SAFETY &m_save_set[55]
SET SCOREBOARD &m_save_set[56]
SET SEPARATOR TO &m_save_set[57]
SET SHADOWS &m_save_set[58]
SET SPACE &m_save_set[59]
SET STATUS &m_save_set[60]
SET STATUS BAR &m_save_set[61]
SET STEP &m_save_set[62]
SET STICKY &m_save_set[63]
SET SYSMENU &m_save_set[64]
SET TALK &m_save_set[65]
SET TEXTMERGE &m_save_set[66]
SET TYPEAHEAD TO (m_save_set[67])
SET UDFPARMS &m_save_set[68]
SET UNIQUE &m_save_set[69]


FOR m_ctr = 70 to 93
	m_save_set[m_ctr] = SCHEME(m_ctr-69)
NEXT m_ctr

if !empty(m_save_set[94])
	select (m_save_set[94])
endif

return
   





