*	Copyright 1993 Eugene Mondrus & Impath Laboratories
*	Procedure to Save operating enviroment
*	to a file
*	Usage : =savenv(filename)
*	Returns: (nothing)
*	This file is hereby released for general public use and
*	is free to be distributed and copied AS LONG AS NO MONIES
*
*   THIS PRODUCT IS OFFERED "AS IS" WITHOUT  ANY  WARRANTY  OF  ANY  KIND
*   INCLUDING,  BUT  NOT  LIMITED TO IMPLIED WARRANTIES OF MERCHANTABILITY
*   AND FITNESS FOR A PARTICULAR  PURPOSE,  ALL  OF  WHICH  ARE  EXPRESSLY
*   DISCLAIMED.  SHOULD THE PROGRAM PROVE DEFECTIVE, THE USER ASSUMES
*   THE RISK OF PAYING THE ENTIRE COST OF ALL NECESSARY SERVICING, REPAIR,
*   OR  CORRECTION  AND  ANY  INCIDENTAL  OR CONSEQUENTIAL DAMAGES.  IN NO
*   EVENT WILL Impath Laboratories or Eugene Mondrus  BE  LIABLE  FOR  ANY
*   DAMAGES  WHATSOEVER (INCLUDING  WITHOUT  LIMITATION  DAMAGES FOR LOSS 
*   OF BUSINESS PROFITS,BUSINESS INTERRUPTION, LOSS OF BUSINESS INFORMATION
*   AND  THE  LIKE)ARISING OUT OF THE USE OR THE INABILITY TO USE THIS
*   PRODUCT EVEN IF Impath Laboratories or Eugene Mondrus HAS BEEN ADVISED
*   OF THE POSSIBILITY OF SUCH DAMAGES.
*
* 	11/1/93  8:28 pm EM :	Fix for not saving of Set Skip
*				Set skip is not an enviroment variable
*				It has to be treated individually for each work area
*
*	11/19/93 2:37 pm EM :	Fixed an error in declaring the save array as only 9 columns instead of 10
*							This error only manifested itself in One to Many relations.

function savenv
parameter tempfile

private maxworkarea,tempcount,currarea,tempstring,tempreloff
private m_save,temp_sel

EXTERNAL ARRAY m_save_set
EXTERNAL ARRAY m_savework



do case
	case "2.0" $ version()
		maxworkarea=25		&& if were running fox 2.0 max work areas = 25
	case !("(X)"  $ version())
		maxworkarea=25		&& if were not running extended max work areas = 25
	case "(X)" $ version()
		maxworkarea=225		&& if we are running extended max work areas = 225	
	otherwise
		maxworkarea=25		&& Default is 25
endcase


declare m_savework[maxworkarea,10]	&& array to save the work areas
declare m_save_set[95]					&& array to save old sets


store "" to m_savework				&& init the arrays to blank
store "" to m_save_set					&& init the arrays to blank

*1 	is physical name of database
*2 	is alias of database
*3 	is any filter expressions for database
*4 	is all relations in a string, parsed with command code
*		ready for execution		i.e. : "set relation to XXX into YYY
*5 	is all indexes (IDX&CDX) files ready to be called like above
*6 	is controlling index
*7 	Record pointer in current database
*8 	is database used exclusively or not
*9 	String neccesary to unset relations
*10	Set Skip support for this area


temp_sel=select()		&& Temporaraly store the currently selected database

for currarea=1 to maxworkarea	&& for all work areas

	if !used(currarea)			&& if there is nothing there go back to top of loop
		loop
	endif
	
	select (currarea)			&& select work area to work on
	
	m_savework[currarea,1]=dbf(currarea)		&& store the name of the physical dbase to array[1]
	m_savework[currarea,2]=alias(currarea)		&& store the alias of the dbase to array[2]
	m_savework[currarea,3]=filter(currarea)	&& store any filter of the dbase to array[3] 
 	
	tempcount=1					&& initialize variables for the relation string
	tempstring=""
	tempreloff=""
	do while !empty(relation(tempcount,currarea))		&& while relations still exist do

*			Construct a string from which we can restore relations 
*			based on current relations
* 			Store current relations into tempstring in an order that allows a restore
		
		tempstring=tempstring+relation(tempcount,currarea)+" into "+target(tempcount,currarea)+","		
		
*			Store the targets of the previous relations, so as to avoid the "relation already exists" error

		tempreloff=tempreloff+target(tempcount,currarea)+","
			
		tempcount=tempcount+1
	enddo

* 		Take commas off the ends of the two strings
	
	tempstring=iif(right(tempstring,1)=",",left(tempstring,len(tempstring)-1),tempstring)
	tempreloff=iif(right(tempreloff,1)=",",left(tempreloff,len(tempreloff)-1),tempreloff)


* 		Add the Additive keyword if neccesary
	
	tempstring=iif(!empty(tempstring),alltrim(tempstring+" Additive"),tempstring)
	
	
	m_savework[currarea,4]=tempstring		&& Store the relations
	m_savework[currarea,9]=tempreloff		&& store the targets

	
	tempcount=1
	tempstring=""
	do while !empty(ndx(tempcount,currarea))
		
*		While not empty store the idx's into a restore string
	
		tempstring=tempstring+ndx(tempcount,currarea)+","
		tempcount=tempcount+1
	enddo
	
* 		While not empty store the cdx's into a restore string
	
	tempcount=1
	do while !empty(cdx(tempcount))
		tempstring=tempstring+cdx(tempcount,currarea)+','
		tempcount=tempcount+1
	enddo
	
* 		Get rid of the commas and add an ADDITIVE if neccesary
	
	tempstring=iif(right(tempstring,1)=",",left(tempstring,len(tempstring)-1),tempstring)	
	tempstring=iif(!empty(tempstring),alltrim(tempstring+" Additive"),tempstring)
	
	
	m_savework[currarea,5]=tempstring			&& Store the restore index string
	m_savework[currarea,6]=sys(22,currarea)		&& Store the master controlling index
	m_savework[currarea,7]=recno(currarea)		&& Store the current record number
	
	m_savework[currarea,10]=set("skip")			&& Store the current set skip setting for this work area
	
	if sys(2011)="Exclusive"
		m_savework[currarea,8]=sys(2011)	&& Store if the database has been opened exclusively
	endif
endfor


*	Store the following sets into an array

m_save_set[1]=SET("ALTERNATE")
m_save_set[2]=SET("ANSI")
m_save_set[3]=SET("AUTOSAVE")
m_save_set[4]=SET("BELL")
m_save_set[5]=SET("BLINK")
m_save_set[6]=SET("BLOCKSIZE")
m_save_set[7]=SET("BRSTATUS")
m_save_set[8]=SET("CARRY")
m_save_set[9]=SET("CENTURY")
m_save_set[10]=SET("CLEAR")
m_save_set[11]=SET("CLOCK")
m_save_set[12]=SET("COLOR")
m_save_set[13]=SET("COMPATIBLE")
m_save_set[14]=SET("CONFIRM")
m_save_set[15]=SET("CONSOLE")
m_save_set[16]=SET("CURRENCY")
m_save_set[17]=SET("CURSOR")
m_save_set[18]=SET("DATE")
m_save_set[19]=SET("DEBUG")
m_save_set[20]=SET("DECIMALS")
m_save_set[21]=SET("DEFAULT")
m_save_set[22]=SET("DELETED")
m_save_set[23]=SET("DELIMITERS")
m_save_set[24]=SET("DEVICE")
m_save_set[25]=SET("DOHISTORY")
m_save_set[26]=SET("ECHO")
m_save_set[27]=SET("ESCAPE")
m_save_set[28]=SET("EXACT")
m_save_set[29]=SET("EXCLUSIVE")
m_save_set[30]=SET("FIXED")
m_save_set[31]=SET("FULLPATH")
m_save_set[32]=SET("HEADING")
m_save_set[33]=SET("HELP")
m_save_set[34]=SET("HISTORY")
m_save_set[35]=SET("HOURS")
m_save_set[36]=SET("INTENSITY")
m_save_set[37]=SET("LOCK")
m_save_set[38]=SET("LOGERRORS")
m_save_set[39]=SET("MACKEY")
m_save_set[40]=SET("MARGIN")
m_save_set[41]=SET("MARK")
m_save_set[42]=SET("MEMOWIDTH")
m_save_set[43]=SET("MENU")
m_save_set[44]=SET("MESSAGE")
m_save_set[45]=SET("MULTILOCKS")
m_save_set[46]=SET("NEAR")
m_save_set[47]=SET("NOTIFY")
m_save_set[48]=SET("ODOMETER")
m_save_set[49]=SET("OPTIMIZE")
m_save_set[50]=SET("PATH")
m_save_set[51]=SET("POINT")
m_save_set[52]=SET("PRINTER")
m_save_set[53]=SET("REFRESH")
m_save_set[54]=SET("REPROCESS")
m_save_set[55]=SET("SAFETY")
m_save_set[56]=SET("SCOREBOARD")
m_save_set[57]=SET("SEPARATOR")
m_save_set[58]=SET("SHADOWS")
m_save_set[59]=SET("SPACE")
m_save_set[60]=SET("STATUS")
m_save_set[61]=SET("STATUS BAR")
m_save_set[62]=SET("STEP")
m_save_set[63]=SET("STICKY")
m_save_set[64]=SET("SYSMENU")
m_save_set[65]=SET("TALK")
m_save_set[66]=SET("TEXTMERGE")
m_save_set[67]=SET("TYPEAHEAD")
m_save_set[68]=SET("UDFPARMS")
m_save_set[69]=SET("UNIQUE")


*	Store the collor sets into an array

FOR m_ctr = 70 TO 93
	m_save_set[m_ctr] = SCHEME(m_ctr-69)
NEXT m_ctr

m_save_set[94]=temp_sel		&& store the currently selected area in array[95]

*	Save all variables to file 

save to (tempfile) all like m_save????

return 



